Subject: bug#19757: closed (Re: bug#19757: [PATCH] gc: ignore trailing slash or subdirectories for `guix gc -d')

From: [email-masked] (GNU bug Tracking System)
Date: Tue, 26 May 2015 20:28:03 +0000

Your bug report

#19757: ignore trailing slash for `guix gc -d' /gnu/store/...something/

which was filed against the guix package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
19757: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=19757
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#19757: [PATCH] gc: ignore trailing slash or subdirectories for `guix gc -d'
From: [email-masked] (Ludovic Courtès)
To: Cyrill Schenkel <[email-masked]>
Cc: [email-masked]
Date: Tue, 26 May 2015 22:27:40 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

Cyrill Schenkel <[email-masked]> skribis:

> From 7385c2ddd4ca50cb80afcd315287eaadff4d8421 Mon Sep 17 00:00:00 2001
> From: Cyrill Schenkel <[email-masked]>
> Date: Sun, 24 May 2015 13:46:37 +0200
> Subject: [PATCH] gc: ignore trailing slash or subdirectories for `guix gc -d'
>
> Fixes <http://bugs.gnu.org/19757>.
>
> * guix/scripts/gc.scm (guix-gc): Convert paths to direct store paths.
> * guix/store.scm (direct-store-path): Get rid of subdirectories in store path.
> * tests/guix-gc.sh: New tests.

Applied, thank you!

I tweaked ‘direct-store-path’ so that it gracefully handles non-store
file names such as “/dev/null”.

Ludo’.

Subject: Re: ignore trailing slash for `guix gc -d' /gnu/store/...something/
From: [email-masked] (Ludovic Courtès)
To: [email-masked]
Cc: [email-masked], [email-masked]
Date: Tue, 03 Feb 2015 21:57:04 +0100
List-Id: <debbugs-submit.debbugs.gnu.org>

[email-masked] skribis:

> Package: guix
> Version: 0.8.1
>
> When I invoke `guix gc -d /path', success of the command depends whether /path ends with slash or not:
>
> $ guix gc -d /gnu/store/mgqk0kv5jckrd7l5cwj68fp7cz2l4qqj-luajit-2.0.3/
> guix gc: error: build failed: path `/gnu/store/mgqk0kv5jckrd7l5cwj68fp7cz2l4qqj-luajit-2.0.3/' is not in the Nix store
>
> $ guix gc -d /gnu/store/mgqk0kv5jckrd7l5cwj68fp7cz2l4qqj-luajit-2.0.3
> finding garbage collector roots...
> cannot read potential root `/var/guix/manifests'
> deleting `/gnu/store/73b760g2nr9syhznydgly8r7vl2k9z11-profile'
> deleting `/gnu/store/mgqk0kv5jckrd7l5cwj68fp7cz2l4qqj-luajit-2.0.3'
> deleting `/gnu/store/trash'
> deleting unused links...
> note: currently hard linking saves 247.60 MiB
>
>
> * with the misleading error message it is usability bug
> * it should be safe always try to remove slash from the end
> * other commands may be affected too and the behaviour should be consistent for all commands

What behavior do you think would be appropriate when running, say:

  guix gc -d /gnu/store/mgqk0kv5jckrd7l5cwj68fp7cz2l4qqj-luajit-2.0.3/bin/lua

Should it be equivalent to:

  guix gc -d /gnu/store/mgqk0kv5jckrd7l5cwj68fp7cz2l4qqj-luajit-2.0.3

I would think so, but I’d like to have feedback.

Thanks,
Ludo’.

PS: Make sure to use [email-masked] for bug reports.